#include <cstring>
#include <iostream>
#include <cstdio>

#define MAX 30

short int grafo[MAX][MAX];
short int cores[MAX];
int n;
int ncores;

using namespace std;


void printMat(short int mat[MAX][MAX]){
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			cout << mat[i][j] << " ";
		}
		cout << endl;
	}
}

void printvet(short int vet[MAX]){
	for (int i = 0; i < n; ++i)
	{
		cout << vet[i] << " ";
	}
	cout << endl;
}

bool valido(int v, int c){
	// para todos os adjacente a v, verifica se posso atribuir a cor c
	for (int i = 0; i < n; ++i)
		if (grafo[v][i] == 1 && c == cores[i])
			return false; 
	return true;
}


bool Coloracao(int v){

	// se chegou ao fim...
	if (v == n){
		return true;
	}

	// testa para o vertice v, todas as cores.....
	for (int c = 1; c <= ncores; ++c){
		
		if (valido(v,c)){
			// colore o vertice v com a cor c
			cores[v] = c;
			// backtracking....
			if (Coloracao(v+1))
				return true;
			// retira a cor do vertice v
			cores[v] = 0;
		}
	}
	// se tudo falhar... diz que nao conseguiu por a cor.....
	return false;
}

int main(int argc, char const *argv[])
{
	cin >> ncores;
	cin >> n;
	
	// lendo a matriz adjencia
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> grafo[i][j];

	memset(cores, 0, sizeof cores);
	if (Coloracao(0)){
		 printvet(cores);
		 cout << endl;
	} else 
	cout << "Nao tem solucao para esta qtd de cores..." << endl;

	printMat(grafo);
	cout << endl;

	return 0;
}